/*
	PluginManager v4
	Copyright (C) 2011, plum

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// header
#include "plugin_mgr.h"

// info
PSP_MODULE_INFO("PluginManager", 0x1007, 0, 4);

// global
char boot_path[256];
STMOD_HANDLER previous;
SceModuleContainer *mod_list;

// function
void ClearCaches(void)
{
	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();
}

int OnModuleStart(SceModule2 *mod)
{
	SceModuleContainer *top = mod_list;

	while(top != NULL)
	{
		if(strcmp(mod->modname, top->mod.modname) == 0)
		{
			PatchThreadStub(mod, top);
			AdjustContainer(top, 0);
		}

		top = top->next;
	}

	return previous ? previous(mod) : 0;
}

int module_start(SceSize args, void *argp)
{
	if(argp != NULL)
		strcpy(boot_path, (char *)argp);

	previous = sctrlHENSetStartModuleHandler(OnModuleStart);
	PatchModuleMgr();
	InitThreadList();
	CreateStartThread("PluginMgrThread", PluginMgrThread, 16, 0x1000);
	return 0;
}

int module_stop(SceSize args, void *argp)
{
	return 0;
}

